=== Tests/RunCMake/InstallParallel/subdir-1/subdir-3/CMakeLists.txt ===
install(CODE "message(installing:${CMAKE_CURRENT_SOURCE_DIR})")
